.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include AviCap.inc
include C:\RadASM\Masm\Inc\RADbg.inc
.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

	invoke InitCommonControls
	invoke LoadLibrary,addr libNAMEAviCap
	.if eax
		mov		hLibAviCap,eax
		;get the icon
		invoke LoadIcon,hInstance,IDI_MAINICO
		;save the handle
		mov		hIco,eax
		;use DialogBox because this will be our main window
		invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
		invoke FreeLibrary,hLibAviCap
		;unload the icon
		invoke DestroyIcon,hIco
	.else
		;DLL not found
		invoke MessageBox,NULL,addr libNAMEAviCap,addr libNAMEAviCap,MB_OK
	.endif
	invoke ExitProcess,0

;########################################################################

initCapWindow proc hPic:DWORD
	LOCAL	rect:RECT

	invoke GetClientRect,hPic,addr rect
	push	0
	push	hPic
	push	rect.bottom
	push	rect.right
	push	rect.top
	push	rect.left
	push	WS_CHILD or WS_VISIBLE or WS_BORDER
	push	offset libNAMEAviCap
	invoke GetProcAddress,hLibAviCap,addr procNAMEAviCap
	call	eax
	ret

initCapWindow endp

;########################################################################

initCapDriver proc hCtrl:HWND

	invoke SendMessage,hCtrl,WM_CAP_DRIVER_CONNECT,capDriverIndex,NULL
	mov		eax,1000
	mov		ecx,capPrevRate
	xor		edx,edx
	div		ecx
	invoke SendMessage,hCtrl,WM_CAP_SET_PREVIEWRATE,eax,0
	invoke SendMessage,hCtrl,WM_CAP_SET_SCALE,1,0
	invoke SendMessage,hCtrl,WM_CAP_SET_PREVIEW,1,0
	invoke SendMessage,hCtrl,WM_CAP_SET_OVERLAY,1,0
	ret

initCapDriver endp

;########################################################################

disconnectCapDriver proc hCtrl:HWND

	invoke SendMessage,hCtrl,WM_CAP_DRIVER_DISCONNECT,capDriverIndex,NULL
	ret

disconnectCapDriver endp

;########################################################################

getDriver proc iDriver:DWORD

	push	32
	push	offset capDriverVersion
	push	32
	push	offset capDriverName
	push	iDriver		 ;Driver index
	invoke GetProcAddress,hLibAviCap,addr procNAMEAviCap1
	call	eax
	ret

getDriver endp

;########################################################################

CapSelectProc PROC hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	hList:DWORD
	LOCAL	iList:DWORD
	LOCAL	iDriver:DWORD

	.if uMsg==WM_INITDIALOG
		;set icon
		invoke SendMessage,hWin,WM_SETICON,FALSE,hIco
		;get listbox hwnd
		invoke GetDlgItem,hWin,IDC_LST1
		mov		hList,eax
		mov		iDriver,0
	  @@:
		;get driver name
		invoke getDriver,iDriver
		.if eax
			;add driver to listbox
			invoke SendMessage,hList,LB_ADDSTRING,0,addr capDriverName
			mov		iList,eax
			invoke SendMessage,hList,LB_SETITEMDATA,iList,iDriver
		.endif
		inc		iDriver
		cmp		iDriver,10
		jne		@b
		invoke SendMessage,hList,LB_SETCURSEL,0,0
	.elseif uMsg==WM_CLOSE
		invoke EndDialog,hWin,NULL
	.elseif uMsg==WM_COMMAND
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==BN_CLICKED || dx==LBN_DBLCLK
			.if ax==IDCANCEL
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.elseif ax==IDOK || ax==IDC_LST1
				invoke disconnectCapDriver,hCap
				invoke GetDlgItem,hWin,IDC_LST1
				mov		hList,eax
				invoke SendMessage,hList,LB_GETCURSEL,0,0
				invoke SendMessage,hList,LB_GETITEMDATA,eax,0 
				mov		capDriverIndex,eax
				invoke initCapDriver,hCap
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.else
		mov eax,FALSE
		ret
	.endif
	mov  eax,TRUE
	ret

CapSelectProc endp

;########################################################################

DlgProc proc hDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	rect:RECT

	.if uMsg==WM_INITDIALOG
		;set icon
		invoke SendMessage,hDlg,WM_SETICON,FALSE,hIco
		;init capture window
		invoke GetDlgItem,hDlg,IDC_STC1
		invoke initCapWindow,eax
		.if eax
			mov		hCap,eax
			;enable menu
			invoke GetMenu,hDlg
			invoke EnableMenuItem,eax,1,MF_BYPOSITION or MF_ENABLED
			invoke initCapDriver,hCap
		.else
			invoke MessageBox,hDlg,addr libNAMEAviCap,addr libNAMEAviCap,MB_OK
		.endif
	.elseif uMsg==WM_CLOSE
		invoke disconnectCapDriver,hCap
		;end the program
		invoke EndDialog,hDlg,0
	.elseif uMsg==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke disconnectCapDriver,hCap
			;end the program
			invoke EndDialog,hDlg,0
		.elseif eax==IDM_FILE_START
			invoke SendMessage,hCap,WM_CAP_SEQUENCE,0,0
;PrintHex eax
		.elseif eax==IDM_FILE_END
			invoke SendMessage,hCap,WM_CAP_FILE_SAVE_AS,0,addr szMyCapture
;PrintHex eax
			invoke SendMessage,hCap,WM_CAP_STOP,0,0
;PrintHex eax
		.elseif eax==IDM_SOURCE_SELECT
			;Select driver
			invoke DialogBoxParam,hInstance,IDD_DIALOG2,hDlg,addr CapSelectProc,NULL
		.elseif eax==IDM_SOURCE_SOURCE
			invoke SendMessage,hCap,WM_CAP_DLG_VIDEOSOURCE,0,0
		.elseif eax==IDM_SOURCE_VIDEOFORMAT
			invoke SendMessage,hCap,WM_CAP_DLG_VIDEOFORMAT,0,0
		.elseif eax==IDM_SOURCE_AUDIOFORMAT
			invoke SendMessage,hCap,WM_CAP_DLG_VIDEODISPLAY,0,0
		.elseif eax==IDM_SOURCE_COMP
			invoke SendMessage,hCap,WM_CAP_DLG_VIDEOCOMPRESSION,0,0
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hDlg,addr AppName,addr AboutMsg,hIco
		.endif
	.elseif uMsg==WM_SIZE
		invoke GetClientRect,hDlg,addr rect
		invoke GetDlgItem,hDlg,IDC_STC1
		invoke MoveWindow,eax,0,0,rect.right,rect.bottom,TRUE
		invoke MoveWindow,hCap,0,0,rect.right,rect.bottom,TRUE
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

end start



